#include <Stats.h>

#include <cmath>

double sampleMean(const double* const x, const int N){
  //mean = 1/N*sum(all xi) = sum/N
  int i;
  double sum = 0;
  for ( i = 0; i < N; i++ ) {
    sum += x[i];
  }

  double mean = sum / double(N);
  return mean;
}

double sampleVariance(const double* const x, const int N){
  //s^2 = 1/(N-1)*sum( (xi-mean)^2 ) = sum / (N-1)
  int i;
  double sum = 0;
  double mean = sampleMean(x, N);
  for ( i = 0; i < N; i++ ) {
    double diff = x[i] - mean;
    sum += diff*diff;
  }

  double s2 = sum / double(N-1);

  return s2;
}

double sampleStdDev(const double* const x, const int N) {
  double var = sampleVariance(x, N);
  double s = sqrt(var);
  return s;
}

