#ifndef __UTILITIES_H__
#define __UTILITIES_H__

#include <cmath>

#ifndef DUMP
#define DUMP(a) cout << #a<<"="<< (a) << endl
#endif

#define ODD(x) ((x)&1)
#define EVEN(x) !ODD(x)

#define EPSIL 0.0000001
#define EQUALS(x, y) fabs(x-y) < EPSIL

//!Convert one type into another.
template <typename T1, typename T2>
struct Convert
{
    T2 operator()(const T1& v) const { return T2(v); }
};

//!Returns nearest integer to the input.
int myRound (const double& input);

//!Return the ceiling of a double.
int myCeil (const double& d);

#endif
