% Tai Meng
% CMPT775 2006-Spring
% Final Project

% This program traverses a neighborhood data file int he current direcotry
% and makes use of the plot data contained to produce a single plot.
% produce plots.

% Please see plotNeighborhood.cpp for a specification of the format of the
% data file.

% First read in the tuples (radius, neighborhoodSize) for CC, plot them.
% Then read in the tuples (radius, neighborhoodSize) for BCC, overlay
% the plot on the CC plot.

% Finally, the the plotted image (in .png format) is saved in the
% directory ../images/stage_2/

function plotNeighborhood()
    plotFigure('neighborhood_50.dat', '../images/stage_2/neighborhoods.png');
end

function plotFigure(filename, file_out)
   
    plotFile=fopen(filename);
    dims=fscanf(plotFile, '%i', [1,2]);
    cc_neighborhood=fscanf(plotFile, '%f', dims); 
    size(cc_neighborhood)
    radii_cc = cc_neighborhood(1, :);
    sizes_cc = cc_neighborhood(2, :);
    
    bcc_neighborhood=fscanf(plotFile, '%f', dims);  
    radii_bcc = bcc_neighborhood(1, :);
    sizes_bcc = bcc_neighborhood(2, :); 
    fclose(plotFile);
    
    scrsz = get(0,'ScreenSize');
    fig=figure('Position',scrsz);
    axes=subplot(1,1,1);
    plot(radii_cc,sizes_cc,'-*g');
    
    title('CC & BCC Neighborhood Sizes');
    xlabel('Radius'); ylabel('Neighborhood Size');
    hold on; %overlay next plot
    plot(radii_bcc,sizes_bcc,'-*r');
    legend(axes,{'CC','BCC'},'Position',[0.450 0.8489 0.08301 0.05469]);
    
    saveas(fig, file_out);
end


